## librdkafka 2.8.0

=== Makefile ===
LIBSUBDIRS=	src src-cpp

CHECK_FILES+=	CONFIGURATION.md \
		examples/rdkafka_example examples/rdkafka_performance \
		examples/rdkafka_example_cpp

DOC_FILES+=	LICENSE LICENSES.txt INTRODUCTION.md README.md \
		CONFIGURATION.md STATISTICS.md CHANGELOG.md

PKGNAME?=	librdkafka
VERSION?=	$(shell python3 packaging/get_version.py src/rdkafka.h)

# Jenkins CI integration
BUILD_NUMBER ?= 1

# Skip copyright check in the following paths
MKL_COPYRIGHT_SKIP?=^(tests|packaging|src/nanopb|src/opentelemetry)


.PHONY:

all: mklove-check libs CONFIGURATION.md check TAGS

include mklove/Makefile.base

libs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d || exit $?; done)

CONFIGURATION.md: src/rdkafka.h examples
	@printf "$(MKL_YELLOW)Updating $@$(MKL_CLR_RESET)\n"
	@echo "# Configuration properties" > CONFIGURATION.md.tmp
	@(examples/rdkafka_performance -X list | \
		sed 's/||/\\|\\|/g' >> \
		CONFIGURATION.md.tmp; \
		cmp CONFIGURATION.md CONFIGURATION.md.tmp || \
		mv -f CONFIGURATION.md.tmp CONFIGURATION.md; \
		rm -f CONFIGURATION.md.tmp)

file-check: CONFIGURATION.md LICENSES.txt examples
check: file-check
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

install-subdirs: libs
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d install || exit $?; done)

install: install-subdirs doc-install

uninstall-subdirs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d uninstall || exit $?; done)

uninstall: uninstall-subdirs doc-uninstall

examples tests: .PHONY libs
	$(MAKE) -C $@

docs:
	doxygen Doxyfile
	@echo "Documentation generated in staging-docs"

clean-docs:
	rm -rf staging-docs

clean:
	@$(MAKE) -C tests $@
	@$(MAKE) -C examples $@
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ ; done)

distclean: clean deps-clean
	./configure --clean
	rm -f config.log config.log.old

archive:
	git archive --prefix=$(PKGNAME)-$(VERSION)/ \
		-o $(PKGNAME)-$(VERSION).tar.gz HEAD
	git archive --prefix=$(PKGNAME)-$(VERSION)/ \
		-o $(PKGNAME)-$(VERSION).zip HEAD

rpm: distclean
	$(MAKE) -C packaging/rpm

LICENSES.txt: .PHONY
	@(for i in LICENSE LICENSE.*[^~] ; do (echo "$$i" ; echo "--------------------------------------------------------------" ; cat $$i ; echo "" ; echo "") ; done) > $@.tmp
	@cmp $@ $@.tmp || mv -f $@.tmp $@ ; rm -f $@.tmp


TAGS: .PHONY
	@(if which etags >/dev/null 2>&1 ; then \
		echo "Using etags to generate $@" ; \
		git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h)$$' | \
			etags -f $@.tmp - ; \
		cmp $@ $@.tmp || mv $@.tmp $@ ; rm -f $@.tmp ; \
	 elif which ctags >/dev/null 2>&1 ; then \
		echo "Using ctags to generate $@" ; \
		git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h)$$' | \
			ctags -e -f $@.tmp -L- ; \
		cmp $@ $@.tmp || mv $@.tmp $@ ; rm -f $@.tmp ; \
	fi)

coverity: Makefile.config
	@(which cov-build >/dev/null 2>&1 || echo "Make sure coverity../bin is in your PATH")
	@(cd src && \
	 make clean && \
	 (rm -rf cov-int cov-librdkafka.tgz cov-build || true) && \
	 cov-build --dir cov-int make -j && \
	 tar cvzf ../cov-librdkafka.tgz cov-int && \
	 printf "$(MKL_GREEN)Now upload cov-librdkafka.tgz to Coverity for analysis$(MKL_CLR_RESET)\n")


style-check:
	@(packaging/tools/style-format.sh \
		$$(git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h|py)$$') )

style-check-changed:
	@(packaging/tools/style-format.sh \
		$$( (git diff --name-only ; git diff --name-only --staged) | egrep '\.(c|cpp|h|py)$$'))

style-fix:
	@(packaging/tools/style-format.sh --fix \
		$$(git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h|py)$$'))

style-fix-changed:
	@(packaging/tools/style-format.sh --fix \
		$$( (git diff --name-only ; git diff --name-only --staged) | egrep '\.(c|cpp|h|py)$$'))

=== tests/CMakeLists.txt ===
set(
    sources
    0000-unittests.c
    0001-multiobj.c
    0002-unkpart.c
    0003-msgmaxsize.c
    0004-conf.c
    0005-order.c
    0006-symbols.c
    0007-autotopic.c
    0008-reqacks.c
    0009-mock_cluster.c
    0011-produce_batch.c
    0012-produce_consume.c
    0013-null-msgs.c
    0014-reconsume-191.c
    0015-offset_seeks.c
    0016-client_swname.c
    0017-compression.c
    0018-cgrp_term.c
    0019-list_groups.c
    0020-destroy_hang.c
    0021-rkt_destroy.c
    0022-consume_batch.c
    0025-timers.c
    0026-consume_pause.c
    0028-long_topicnames.c
    0029-assign_offset.c
    0030-offset_commit.c
    0031-get_offsets.c
    0033-regex_subscribe.c
    0034-offset_reset.c
    0035-api_version.c
    0036-partial_fetch.c
    0037-destroy_hang_local.c
    0038-performance.c
    0039-event.c
    0040-io_event.c
    0041-fetch_max_bytes.c
    0042-many_topics.c
    0043-no_connection.c
    0044-partition_cnt.c
    0045-subscribe_update.c
    0046-rkt_cache.c
    0047-partial_buf_tmout.c
    0048-partitioner.c
    0049-consume_conn_close.c
    0050-subscribe_adds.c
    0051-assign_adds.c
    0052-msg_timestamps.c
    0053-stats_cb.cpp
    0054-offset_time.cpp
    0055-producer_latency.c
    0056-balanced_group_mt.c
    0057-invalid_topic.cpp
    0058-log.cpp
    0059-bsearch.cpp
    0060-op_prio.cpp
    0061-consumer_lag.cpp
    0062-stats_event.c
    0063-clusterid.cpp
    0064-interceptors.c
    0065-yield.cpp
    0066-plugins.cpp
    0067-empty_topic.cpp
    0068-produce_timeout.c
    0069-consumer_add_parts.c
    0070-null_empty.cpp
    0072-headers_ut.c
    0073-headers.c
    0074-producev.c
    0075-retry.c
    0076-produce_retry.c
    0077-compaction.c
    0078-c_from_cpp.cpp
    0079-fork.c
    0080-admin_ut.c
    0081-admin.c
    0082-fetch_max_bytes.cpp
    0083-cb_event.c
    0084-destroy_flags.c
    0085-headers.cpp
    0086-purge.c
    0088-produce_metadata_timeout.c
    0089-max_poll_interval.c
    0090-idempotence.c
    0091-max_poll_interval_timeout.c
    0092-mixed_msgver.c
    0093-holb.c
    0094-idempotence_msg_timeout.c
    0095-all_brokers_down.cpp
    0097-ssl_verify.cpp
    0098-consumer-txn.cpp
    0099-commit_metadata.c
    0100-thread_interceptors.cpp
    0101-fetch-from-follower.cpp
    0102-static_group_rebalance.c
    0103-transactions.c
    0104-fetch_from_follower_mock.c
    0105-transactions_mock.c
    0106-cgrp_sess_timeout.c
    0107-topic_recreate.c
    0109-auto_create_topics.cpp
    0110-batch_size.cpp
    0111-delay_create_topics.cpp
    0112-assign_unknown_part.c
    0113-cooperative_rebalance.cpp
    0114-sticky_partitioning.cpp
    0115-producer_auth.cpp
    0116-kafkaconsumer_close.cpp
    0117-mock_errors.c
    0118-commit_rebalance.c
    0119-consumer_auth.cpp
    0120-asymmetric_subscription.c
    0121-clusterid.c
    0122-buffer_cleaning_after_rebalance.c
    0123-connections_max_idle.c
    0124-openssl_invalid_engine.c
    0125-immediate_flush.c
    0126-oauthbearer_oidc.c
    0127-fetch_queue_backoff.cpp
    0128-sasl_callback_queue.cpp
    0129-fetch_aborted_msgs.c
    0130-store_offsets.c
    0131-connect_timeout.c
    0132-strategy_ordering.c
    0133-ssl_keys.c
    0134-ssl_provider.c
    0135-sasl_credentials.cpp
    0136-resolve_cb.c
    0137-barrier_batch_consume.c
    0138-admin_mock.c
    0139-offset_validation_mock.c
    0140-commit_metadata.cpp
    0142-reauthentication.c
    0143-exponential_backoff_mock.c
    0144-idempotence_mock.c
    0145-pause_resume_mock.c
    0146-metadata_mock.c
    0150-telemetry_mock.c
    8000-idle.cpp
    8001-fetch_from_follower_mock_manual.c
    test.c
    testcpp.cpp
    rusage.c
)

if(NOT WIN32)
    list(APPEND sources sockem.c sockem_ctrl.c)
else()
    list(APPEND sources ../src/tinycthread.c ../src/tinycthread_extra.c)
endif()

add_executable(test-runner ${sources})
target_link_libraries(test-runner PUBLIC rdkafka++)

add_test(NAME RdKafkaTestInParallel COMMAND test-runner -p5)
add_test(NAME RdKafkaTestSequentially COMMAND test-runner -p1)
add_test(NAME RdKafkaTestBrokerLess COMMAND test-runner -p5 -l)

if(NOT WIN32 AND NOT APPLE)
  set(tests_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  add_subdirectory(interceptor_test)
endif()

=== tests/Makefile ===
TESTSRCS_C = $(wildcard [08]*-*.c)
TESTSRCS_CXX= $(wildcard [08]*-*.cpp)
OBJS	  = $(TESTSRCS_C:%.c=%.o) $(TESTSRCS_CXX:%.cpp=%.o)

BIN	  = test-runner
LIBS	 += -lrdkafka++ -lrdkafka
OBJS	 += test.o rusage.o testcpp.o \
		tinycthread.o tinycthread_extra.o rdlist.o sockem.o \
		sockem_ctrl.o
CFLAGS += -I../src
CXXFLAGS += -I../src -I../src-cpp
LDFLAGS += -rdynamic -L../src -L../src-cpp

# Latest Kafka version
KAFKA_VERSION?=3.4.0
# Kafka versions for compatibility tests
COMPAT_KAFKA_VERSIONS?=0.8.2.2 0.9.0.1 0.11.0.3 1.0.2 2.4.1 2.8.1 $(KAFKA_VERSION)

# Non-default scenarios (FIXME: read from scenarios/*)
SCENARIOS?=noautocreate ak23

# A subset of rudimentary (and quick) tests suitable for quick smoke testing.
# The smoke test should preferably finish in under a minute.
SMOKE_TESTS?=0000,0001,0004,0012,0017,0022,0030,0039,0049,0087,0103

-include ../Makefile.config

# Use C++ compiler as linker
CC_LD=$(CXX)

all: $(BIN) run_par

#
# These targets spin up a cluster and runs the test suite
# with different parameters.
#

broker: $(BIN)
	./broker_version_tests.py --conf '{"parallel":1, "args":"-Q"}' $(KAFKA_VERSION)

broker_idempotent: $(BIN)
	./broker_version_tests.py --conf '{"parallel":1, "args":"-P -L -Q"}' $(KAFKA_VERSION)

sasl: $(BIN)
	./sasl_test.py --conf '{"parallel":1, "args":"-L -Q"}' $(KAFKA_VERSION)

# Run the full test suite(s)
full: broker broker_idempotent sasl


#
# The following targets require an existing cluster running (test.conf)
#
quick:
	@echo "Running quick(er) test suite (without sockem)"
	./run-test.sh -Q -E

smoke:
	@echo "Running smoke tests: $(SMOKE_TESTS)"
	TESTS="$(SMOKE_TESTS)" $(MAKE) quick

run_par: $(BIN)
	@echo "Running tests in parallel"
	./run-test.sh

run_seq: $(BIN)
	@echo "Running tests sequentially"
	./run-test.sh -p1

run_local: $(BIN)
	@echo "Running local broker-less tests with idempotent producer"
	./run-test.sh -l -P

run_local_quick: $(BIN)
	@echo "Running quick local broker-less tests with idempotent producer"
	./run-test.sh -l -Q -P

idempotent_par: $(BIN)
	./run-test.sh -P

idempotent_seq: $(BIN)
	./run-test.sh -P

idempotent: idempotent_par

transactions: $(BIN)
	for _test in 0098 0101; do TESTS=$$_test ./run-test.sh ./$(BIN) ; done

# Run unit tests
unit: $(BIN)
	TESTS=0000 ./run-test.sh -p1


# Delete all test topics (based on prefix)
delete_topics:
	TESTS=none ./run-test.sh -D bare

.PHONY:

build: $(BIN) interceptor_test

test.o: ../src/librdkafka.a ../src-cpp/librdkafka++.a interceptor_test



include ../mklove/Makefile.base

ifeq ($(_UNAME_S),Darwin)
interceptor_test: .PHONY
else
interceptor_test: .PHONY
	$(MAKE) -C $@
endif


tinycthread.o: ../src/tinycthread.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<

tinycthread_extra.o: ../src/tinycthread_extra.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<

rdlist.o: ../src/rdlist.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<


clean:
	rm -f *.test $(OBJS) $(BIN)
	$(MAKE) -C interceptor_test clean

# Remove test reports, temporary test files, crash dumps, etc.
clean-output:
	rm -f *.offset stats_*.json core vgcore.* _until_fail_*.log gdbrun??????

realclean: clean clean-output
	rm -f test_report_*.json

java: .PHONY
	make -C java

# Run test-suite with ASAN
asan:
	@(echo "### Running tests with AddressSanitizer")
	(cd .. ; ./dev-conf.sh asan)
	CI=true ./broker_version_tests.py --conf '{"args":"-Q"}' $(KAFKA_VERSION)

# Run test-suite with TSAN
tsan:
	@(echo "### Running tests with ThreadSanitizer")
	(cd .. ; ./dev-conf.sh tsan)
	CI=true ./broker_version_tests.py --conf '{"args":"-Q"}' $(KAFKA_VERSION)

# Run full test-suite with a clean release build
pristine-full:
	@(echo "### Running full test-suite with clean build")
	(cd .. ; ./dev-conf.sh clean)
	make full

# Run backward compatibility tests
compat:
	@(echo "### Running compatibility tests with Apache Kafka versions $(COMPAT_KAFKA_VERSIONS)")
	./broker_version_tests.py --rdkconf '{"args": "-Q"}' \
		$(COMPAT_KAFKA_VERSIONS)

# Run non-default scenarios
scenarios: .PHONY
	@echo "### Running test scenarios: $(SCENARIOS)"
	@(for _SCENARIO in $(SCENARIOS) ; do \
		./broker_version_tests.py --scenario "$$_SCENARIO" $(KAFKA_VERSION) ; \
	done)


# Run a full release / PR test.
# (| is for not running suites in parallel)
release-test: | asan tsan pristine-full scenarios compat

# Check resource usage (requires a running cluster environment)
rusage:
	./run-test.sh -R bare



-include $(DEPS)

=== tests/requirements.txt ===
trivup/trivup-0.12.8.tar.gz
jsoncomment

=== debian/changelog ===
librdkafka (2.8.0-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new symbols.

 -- Faidon Liambotis <paravoid@debian.org>  Sun, 16 Feb 2025 14:45:47 +0200

=== debian/control ===
Source: librdkafka
Priority: optional
Maintainer: Faidon Liambotis <paravoid@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 pkgconf,
 libcurl4-openssl-dev,
 liblz4-dev,
 libsasl2-dev,
 libssl-dev,
 libzstd-dev,
 python3,
 rapidjson-dev,
 zlib1g-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Section: libs
Homepage: https://github.com/confluentinc/librdkafka
Vcs-Git: https://salsa.debian.org/kafka-team/librdkafka.git
Vcs-Browser: https://salsa.debian.org/kafka-team/librdkafka

Package: librdkafka1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing the Apache Kafka protocol
 librdkafka is a C library implementation of the Apache Kafka protocol,
 providing Producer, Consumer and Admin clients. It was designed with message
 delivery reliability and high performance in mind, current figures exceed 1
 million msgs/second for the producer and 3 million msgs/second for the
 consumer.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C shared library.

Package: librdkafka++1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing the Apache Kafka protocol (C++ bindings)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 providing Producer, Consumer and Admin clients. It was designed with message
 delivery reliability and high performance in mind, current figures exceed 1
 million msgs/second for the producer and 3 million msgs/second for the
 consumer.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C++ shared library.

Package: librdkafka-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 librdkafka++1 (= ${binary:Version}),
 librdkafka1 (= ${binary:Version}),
 libcurl4-openssl-dev,
 liblz4-dev,
 libsasl2-dev,
 libssl-dev,
 libzstd-dev,
 zlib1g-dev,
 ${misc:Depends}
Description: library implementing the Apache Kafka protocol (development headers)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 providing Producer, Consumer and Admin clients. It was designed with message
 delivery reliability and high performance in mind, current figures exceed 1
 million msgs/second for the producer and 3 million msgs/second for the
 consumer.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the development headers.

## librdkafka 2.11.1

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,7 @@
 
 PKGNAME?=	librdkafka
 VERSION?=	$(shell python3 packaging/get_version.py src/rdkafka.h)
+SHELL	=	bash
 
 # Jenkins CI integration
 BUILD_NUMBER ?= 1

=== examples/CMakeLists.txt ===
if(WIN32)
    set(win32_sources ../win32/wingetopt.c ../win32/wingetopt.h)
endif(WIN32)

add_executable(producer producer.c ${win32_sources})
target_link_libraries(producer PUBLIC rdkafka)

add_executable(producer_cpp producer.cpp ${win32_sources})
target_link_libraries(producer_cpp PUBLIC rdkafka++)

add_executable(consumer consumer.c ${win32_sources})
target_link_libraries(consumer PUBLIC rdkafka)

add_executable(rdkafka_performance rdkafka_performance.c ${win32_sources})
target_link_libraries(rdkafka_performance PUBLIC rdkafka)

add_executable(rdkafka_example_cpp rdkafka_example.cpp ${win32_sources})
target_link_libraries(rdkafka_example_cpp PUBLIC rdkafka++)

add_executable(rdkafka_complex_consumer_example_cpp rdkafka_complex_consumer_example.cpp ${win32_sources})
target_link_libraries(rdkafka_complex_consumer_example_cpp PUBLIC rdkafka++)

add_executable(openssl_engine_example_cpp openssl_engine_example.cpp ${win32_sources})
target_link_libraries(openssl_engine_example_cpp PUBLIC rdkafka++)

add_executable(misc misc.c ${win32_sources})
target_link_libraries(misc PUBLIC rdkafka)

add_executable(idempotent_producer idempotent_producer.c ${win32_sources})
target_link_libraries(idempotent_producer PUBLIC rdkafka)

add_executable(transactions transactions.c ${win32_sources})
target_link_libraries(transactions PUBLIC rdkafka)

add_executable(delete_records delete_records.c ${win32_sources})
target_link_libraries(delete_records PUBLIC rdkafka)

add_executable(list_consumer_groups list_consumer_groups.c ${win32_sources})
target_link_libraries(list_consumer_groups PUBLIC rdkafka)

add_executable(describe_consumer_groups describe_consumer_groups.c ${win32_sources})
target_link_libraries(describe_consumer_groups PUBLIC rdkafka)

add_executable(list_consumer_group_offsets list_consumer_group_offsets.c ${win32_sources})
target_link_libraries(list_consumer_group_offsets PUBLIC rdkafka)

add_executable(alter_consumer_group_offsets alter_consumer_group_offsets.c ${win32_sources})
target_link_libraries(alter_consumer_group_offsets PUBLIC rdkafka)

add_executable(incremental_alter_configs incremental_alter_configs.c ${win32_sources})
target_link_libraries(incremental_alter_configs PUBLIC rdkafka)

add_executable(user_scram user_scram.c ${win32_sources})
target_link_libraries(user_scram PUBLIC rdkafka)

add_executable(describe_topics describe_topics.c ${win32_sources})
target_link_libraries(describe_topics PUBLIC rdkafka)

add_executable(describe_cluster describe_cluster.c ${win32_sources})
target_link_libraries(describe_cluster PUBLIC rdkafka)

add_executable(list_offsets list_offsets.c ${win32_sources})
target_link_libraries(list_offsets PUBLIC rdkafka)

add_executable(elect_leaders elect_leaders.c ${win32_sources})
target_link_libraries(elect_leaders PUBLIC rdkafka)

# The targets below has Unix include dirs and do not compile on Windows.
if(NOT WIN32)
    add_executable(rdkafka_example rdkafka_example.c)
    target_link_libraries(rdkafka_example PUBLIC rdkafka)

    add_executable(rdkafka_complex_consumer_example rdkafka_complex_consumer_example.c)
    target_link_libraries(rdkafka_complex_consumer_example PUBLIC rdkafka)

    add_executable(kafkatest_verifiable_client kafkatest_verifiable_client.cpp)
    target_link_libraries(kafkatest_verifiable_client PUBLIC rdkafka++)

endif(NOT WIN32)

=== examples/Makefile ===
EXAMPLES ?= rdkafka_example rdkafka_performance rdkafka_example_cpp \
	rdkafka_complex_consumer_example rdkafka_complex_consumer_example_cpp \
	kafkatest_verifiable_client \
	producer consumer idempotent_producer transactions \
	delete_records \
	openssl_engine_example_cpp \
	list_consumer_groups \
	describe_consumer_groups \
	describe_topics \
	describe_cluster \
	list_consumer_group_offsets \
	alter_consumer_group_offsets \
	incremental_alter_configs \
	user_scram \
	list_offsets \
	elect_leaders \
	misc

all: $(EXAMPLES)

include ../mklove/Makefile.base

CFLAGS += -I../src
CXXFLAGS += -I../src-cpp

# librdkafka must be compiled with -gstrict-dwarf, but rdkafka_example must not,
# due to some clang bug on OSX 10.9
CPPFLAGS := $(subst strict-dwarf,,$(CPPFLAGS))

rdkafka_example: ../src/librdkafka.a rdkafka_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer (write messages on stdin)"
	@echo "./$@ -P -t <topic> -p <partition>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"

producer: ../src/librdkafka.a producer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

producer_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a producer.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) producer.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

consumer: ../src/librdkafka.a consumer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

idempotent_producer: ../src/librdkafka.a idempotent_producer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

transactions: ../src/librdkafka.a transactions.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

transactions-older-broker.c: ../src/librdkafka.a transactions-older-broker.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

delete_records: ../src/librdkafka.a delete_records.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

list_consumer_groups: ../src/librdkafka.a list_consumer_groups.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

describe_consumer_groups: ../src/librdkafka.a describe_consumer_groups.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

describe_topics: ../src/librdkafka.a describe_topics.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

describe_cluster: ../src/librdkafka.a describe_cluster.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

list_consumer_group_offsets: ../src/librdkafka.a list_consumer_group_offsets.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

alter_consumer_group_offsets: ../src/librdkafka.a alter_consumer_group_offsets.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

incremental_alter_configs: ../src/librdkafka.a incremental_alter_configs.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

rdkafka_complex_consumer_example: ../src/librdkafka.a rdkafka_complex_consumer_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_complex_consumer_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "./$@ <topic[:part]> <topic2[:part]> .."
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"

rdkafka_performance: ../src/librdkafka.a rdkafka_performance.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_performance.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer"
	@echo "./$@ -P -t <topic> -p <partition> -s <msgsize>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"


rdkafka_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

kafkatest_verifiable_client: ../src-cpp/librdkafka++.a ../src/librdkafka.a kafkatest_verifiable_client.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) kafkatest_verifiable_client.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)


rdkafka_complex_consumer_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_complex_consumer_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_complex_consumer_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

rdkafka_consume_batch: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_consume_batch.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_consume_batch.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

openssl_engine_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a openssl_engine_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) openssl_engine_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

user_scram: ../src/librdkafka.a user_scram.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

list_offsets: ../src/librdkafka.a list_offsets.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

elect_leaders: ../src/librdkafka.a elect_leaders.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

misc: ../src/librdkafka.a misc.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

clean:
	rm -f $(EXAMPLES)

=== src-cpp/CMakeLists.txt ===
set(LIBVER 1)

set(
    sources
    ConfImpl.cpp
    ConsumerImpl.cpp
    HandleImpl.cpp
    HeadersImpl.cpp
    KafkaConsumerImpl.cpp
    MessageImpl.cpp
    MetadataImpl.cpp
    ProducerImpl.cpp
    QueueImpl.cpp
    RdKafka.cpp
    TopicImpl.cpp
    TopicPartitionImpl.cpp
)

if(RDKAFKA_BUILD_STATIC)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  set(RDKAFKA_BUILD_MODE STATIC)
else()
  set(RDKAFKA_BUILD_MODE SHARED)
endif()

add_library(rdkafka++ ${RDKAFKA_BUILD_MODE} ${sources})
if(NOT RDKAFKA_BUILD_STATIC)
  set_property(TARGET rdkafka++ PROPERTY SOVERSION ${LIBVER})
endif()

target_link_libraries(rdkafka++ PUBLIC rdkafka)

# Support '#include <rdkafcpp.h>'
target_include_directories(rdkafka++ PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>")
if(NOT RDKAFKA_BUILD_STATIC)
    target_compile_definitions(rdkafka++ PRIVATE LIBRDKAFKACPP_EXPORTS)
endif()

# Generate pkg-config file
set(PKG_CONFIG_VERSION "${PROJECT_VERSION}")
if(NOT RDKAFKA_BUILD_STATIC)
  set(PKG_CONFIG_NAME "librdkafka++")
  set(PKG_CONFIG_DESCRIPTION "The Apache Kafka C/C++ library")
  set(PKG_CONFIG_REQUIRES_PRIVATE "rdkafka")
  set(PKG_CONFIG_CFLAGS "-I\${includedir}")
  set(PKG_CONFIG_LIBS "-L\${libdir} -lrdkafka++")
  set(PKG_CONFIG_LIBS_PRIVATE "-lrdkafka")
  configure_file(
    "../packaging/cmake/rdkafka.pc.in"
    "${GENERATED_DIR}/rdkafka++.pc"
    @ONLY
  )
  install(
    FILES ${GENERATED_DIR}/rdkafka++.pc
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
  )
else()
  set(PKG_CONFIG_NAME "librdkafka++-static")
  set(PKG_CONFIG_DESCRIPTION "The Apache Kafka C/C++ library (static)")
  set(PKG_CONFIG_REQUIRES_PRIVATE "")
  set(PKG_CONFIG_CFLAGS "-I\${includedir} -DLIBRDKAFKA_STATICLIB")
  set(PKG_CONFIG_LIBS "-L\${libdir} \${libdir}/librdkafka++.a")
  if(WIN32)
    string(APPEND PKG_CONFIG_LIBS " -lws2_32 -lsecur32 -lcrypt32")
  endif()

  configure_file(
    "../packaging/cmake/rdkafka.pc.in"
    "${GENERATED_DIR}/rdkafka++-static.pc"
    @ONLY
  )
  install(
    FILES ${GENERATED_DIR}/rdkafka++-static.pc
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
  )
endif()

install(
    TARGETS rdkafka++
    EXPORT "${targets_export_name}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

install(
    FILES "rdkafkacpp.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/librdkafka"
)

=== src/Makefile ===
PKGNAME=	librdkafka
LIBNAME=	librdkafka
LIBVER=		1

-include ../Makefile.config

ifneq ($(wildcard ../.git),)
# Add librdkafka version string from git tag if this is a git checkout
CPPFLAGS += -DLIBRDKAFKA_GIT_VERSION="\"$(shell git describe --abbrev=6 --dirty --tags 2>/dev/null)\""
endif

CPPFLAGS += -I.


SRCS_$(WITH_SASL_CYRUS) += rdkafka_sasl_cyrus.c
SRCS_$(WITH_SASL_SCRAM) += rdkafka_sasl_scram.c
SRCS_$(WITH_SASL_OAUTHBEARER) += rdkafka_sasl_oauthbearer.c
SRCS_$(WITH_SNAPPY) += snappy.c
SRCS_$(WITH_ZLIB) += rdgz.c
SRCS_$(WITH_ZSTD) += rdkafka_zstd.c
SRCS_$(WITH_HDRHISTOGRAM) += rdhdrhistogram.c
SRCS_$(WITH_SSL) += rdkafka_ssl.c
SRCS_$(WITH_CURL) += rdhttp.c
SRCS_$(WITH_OAUTHBEARER_OIDC) += rdkafka_sasl_oauthbearer_oidc.c

SRCS_LZ4 = rdxxhash.c
ifneq ($(WITH_LZ4_EXT), y)
# Use built-in liblz4
SRCS_LZ4 += lz4.c lz4frame.c lz4hc.c
endif
SRCS_y += rdkafka_lz4.c $(SRCS_LZ4)

SRCS_$(WITH_LIBDL) += rddl.c
SRCS_$(WITH_PLUGINS) += rdkafka_plugin.c

ifneq ($(HAVE_REGEX), y)
SRCS_y += regexp.c
endif

SRCS=		rdkafka.c rdkafka_broker.c rdkafka_msg.c rdkafka_topic.c \
		rdkafka_conf.c rdkafka_timer.c rdkafka_offset.c \
		rdkafka_transport.c rdkafka_buf.c rdkafka_queue.c rdkafka_op.c \
		rdkafka_request.c rdkafka_cgrp.c rdkafka_pattern.c \
		rdkafka_partition.c rdkafka_subscription.c \
		rdkafka_assignment.c \
		rdkafka_assignor.c rdkafka_range_assignor.c \
		rdkafka_roundrobin_assignor.c rdkafka_sticky_assignor.c \
		rdkafka_feature.c \
		rdcrc32.c crc32c.c rdmurmur2.c rdfnv1a.c cJSON.c \
		rdaddr.c rdrand.c rdlist.c \
		tinycthread.c tinycthread_extra.c \
		rdlog.c rdstring.c rdkafka_event.c rdkafka_metadata.c \
		rdregex.c rdports.c rdkafka_metadata_cache.c rdavl.c \
		rdkafka_sasl.c rdkafka_sasl_plain.c rdkafka_interceptor.c \
		rdkafka_msgset_writer.c rdkafka_msgset_reader.c \
		rdkafka_header.c rdkafka_admin.c rdkafka_aux.c \
		rdkafka_background.c rdkafka_idempotence.c rdkafka_cert.c \
		rdkafka_txnmgr.c rdkafka_coord.c rdbase64.c \
		rdvarint.c rdbuf.c rdmap.c rdunittest.c \
		rdkafka_mock.c rdkafka_mock_handlers.c rdkafka_mock_cgrp.c \
		rdkafka_error.c rdkafka_fetcher.c rdkafka_telemetry.c \
		rdkafka_telemetry_encode.c rdkafka_telemetry_decode.c \
		nanopb/pb_encode.c nanopb/pb_decode.c nanopb/pb_common.c \
		opentelemetry/metrics.pb.c opentelemetry/common.pb.c opentelemetry/resource.pb.c \
		$(SRCS_y)

HDRS=		rdkafka.h rdkafka_mock.h

OBJS=		$(SRCS:.c=.o)


all: lib check

include ../mklove/Makefile.base

CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a

file-check: lib
check: file-check
	@(printf "%-30s " "Symbol visibility" ; \
		(($(SYMDUMPER) $(LIBFILENAME) | grep rd_kafka_new >/dev/null) && \
		($(SYMDUMPER) $(LIBFILENAME) | grep -v rd_kafka_destroy >/dev/null) && \
		printf "$(MKL_GREEN)OK$(MKL_CLR_RESET)\n") || \
		printf "$(MKL_RED)FAILED$(MKL_CLR_RESET)\n")

install: lib-install
uninstall: lib-uninstall

clean: lib-clean

# Compile LZ4 with -O3
$(SRCS_LZ4:.c=.o): CFLAGS:=$(CFLAGS) -O3

ifeq ($(WITH_LDS),y)
# Enable linker script if supported by platform
LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME_LDS)

$(LIBNAME_LDS): $(HDRS)
	@(printf "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)\n" ; \
	  cat $(HDRS) | ../lds-gen.py > $@)
endif

-include $(DEPS)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -137,7 +137,12 @@
     0144-idempotence_mock.c
     0145-pause_resume_mock.c
     0146-metadata_mock.c
+    0147-consumer_group_consumer_mock.c
+    0149-broker-same-host-port.c
     0150-telemetry_mock.c
+    0151-purge-brokers.c
+    0152-rebootstrap.c
+    0153-memberid.c
     8000-idle.cpp
     8001-fetch_from_follower_mock_manual.c
     test.c

=== packaging/nuget/requirements.txt ===
boto3~=1.38
rpmfile~=1.1
filemagic~=1.6

=== packaging/rpm/Makefile ===
PACKAGE_NAME?=	librdkafka
VERSION?=	$(shell ../get_version.py ../../src/rdkafka.h)

# Jenkins CI integration
BUILD_NUMBER?= 1

MOCK_CONFIG?=default

RESULT_DIR?=pkgs-$(VERSION)-$(BUILD_NUMBER)-$(MOCK_CONFIG)

# Where built packages are copied with `make copy-artifacts`
ARTIFACTS_DIR?=../../artifacts

all: rpm


SOURCES:
	mkdir -p SOURCES

archive: SOURCES
	cd ../../ && \
	git archive --prefix=$(PACKAGE_NAME)-$(VERSION)/ \
		-o packaging/rpm/SOURCES/$(PACKAGE_NAME)-$(VERSION).tar.gz HEAD


build_prepare: archive
	mkdir -p $(RESULT_DIR)
	rm -f $(RESULT_DIR)/$(PACKAGE_NAME)*.rpm


srpm: build_prepare
	/usr/bin/mock \
		-r $(MOCK_CONFIG) \
		$(MOCK_OPTIONS) \
		--define "__version $(VERSION)" \
		--define "__release $(BUILD_NUMBER)" \
		--enable-network \
		--resultdir=$(RESULT_DIR) \
		--no-clean --no-cleanup-after \
		--install epel-release \
		--buildsrpm \
		--spec=librdkafka.spec \
		--sources=SOURCES || \
	(tail -n 100 pkgs-$(VERSION)*/*log ; false)
	@echo "======= Source RPM now available in $(RESULT_DIR) ======="

rpm: srpm
	/usr/bin/mock \
		-r $(MOCK_CONFIG) \
		$(MOCK_OPTIONS) \
		--define "__version $(VERSION)"\
		--define "__release $(BUILD_NUMBER)"\
		--enable-network \
		--resultdir=$(RESULT_DIR) \
		--no-clean --no-cleanup-after \
		--rebuild $(RESULT_DIR)/$(PACKAGE_NAME)*.src.rpm || \
	(tail -n 100 pkgs-$(VERSION)*/*log ; false)
	@echo "======= Binary RPMs now available in $(RESULT_DIR) ======="

copy-artifacts:
	cp $(RESULT_DIR)/*rpm $(ARTIFACTS_DIR)

clean:
	rm -rf SOURCES
	/usr/bin/mock -r $(MOCK_CONFIG) --clean

distclean: clean
	rm -f build.log root.log state.log available_pkgs installed_pkgs \
		*.rpm *.tar.gz

# Prepare ubuntu 14.04 for building RPMs with mock.
#  - older versions of mock needs the config file to reside in /etc/mock,
#    so we copy it there.
#  - add a mock system group (if not already exists)
#  - add the current user to the mock group.
#  - prepare mock environment with some needed packages.
# NOTE: This target should be run with sudo.
prepare_ubuntu:
	apt-get -qq update
	apt-get install -y -qq mock make git python-lzma
	cp *.cfg /etc/mock/
	addgroup --system mock || true
	adduser $$(whoami) mock
	/usr/bin/mock -r $(MOCK_CONFIG) --init
	/usr/bin/mock -r $(MOCK_CONFIG) \
		--enable-network \
		--no-cleanup-after \
		--install epel-release shadow-utils

prepare_centos:
	yum install -y -q mock make git
	cp *.cfg /etc/mock/

=== packaging/tools/requirements.txt ===
flake8
autopep8

=== tests/fuzzers/Makefile ===
PROGRAMS?=fuzz_regex

all: $(PROGRAMS)


fuzz_%:
	$(CC) -fsanitize=address -D WITH_MAIN -g -Wall \
		-I../../src $@.c -o $@ ../../src/librdkafka.a


clean:
	rm -f $(PROGRAMS)

=== tests/interceptor_test/Makefile ===
PKGNAME=	interceptor_test
LIBNAME=	interceptor_test
LIBVER=		1

-include ../../Makefile.config

SRCS=		interceptor_test.c

OBJS=		$(SRCS:.c=.o)

# For rdkafka.h
CPPFLAGS+=-I../../src
LDFLAGS+=-L../../src
LIBS+=-lrdkafka

all: lib

include ../../mklove/Makefile.base

clean: lib-clean

-include $(DEPS)

=== tests/java/Makefile ===

KAFKA_JARS?=$(KAFKA_PATH)/libs

CLASSES=Murmur2Cli.class TransactionProducerCli.class IncrementalRebalanceCli.class

all: $(CLASSES)

%.class: %.java
	CLIENTS_JAR=$$(ls $(KAFKA_JARS)/kafka-clients-*.jar); \
	javac -classpath $$CLIENTS_JAR:$(KAFKA_PATH)/clients/build/classes/java/main $^

clean:
	rm -f *.class

=== debian/changelog ===
librdkafka (2.11.1-2) unstable; urgency=medium

  * Switch to gbp-pq for managing debian/patches.
  * Fix a s390x autopkgtest failure, resulting from a long-standing endianness
    issue in the GetTelemetrySubscriptions codepath, newly identified by a
    test introduced with v2.10.1.
  * Run the test suite in autopkgtests with CI=true, which avoids erroring out
    on slow CPUs, such as is the case with some of the Debian CI workers.

 -- Faidon Liambotis <paravoid@debian.org>  Thu, 28 Aug 2025 20:13:27 +0300

librdkafka (2.11.1-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new symbols.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 26 Aug 2025 12:52:07 +0300

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  python3,
  rapidjson-dev,
  zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/confluentinc/librdkafka

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_EXPORT_BUILDFLAGS=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

include /usr/share/dpkg/buildflags.mk

execute_before_dh_auto_configure:
	# ignore blhc false positives where tools are just listed
	@echo 'blhc: ignore-line-regexp:  +LD +ld'
	@echo 'blhc: ignore-line-regexp:  +CXX +g\+\+'

%:
	dh $@

=== debian/tests/control ===
Tests: examples
Depends: librdkafka-dev, build-essential, pkgconf
Restrictions: allow-stderr

Tests: unittest
Depends: librdkafka-dev, build-essential, pkgconf
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=uversionmangle=s/-(RC|rc|a|b|c)/~$1/,\
     filenamemangle=s/v?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://github.com/confluentinc/@PACKAGE@/tags .*/v?@ANY_VERSION@\.tar\.gz

## librdkafka 2.12.1

=== debian/changelog ===
librdkafka (2.12.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1119072)
    - Drop patch Remove-small-bashism-from-Makefile, merged upstream.
    - Drop patch Fix-type-endianness-issues-in-GetTelemetrySubscriptions,
      merged upstream.
  * De-vendor external dependencies:
    - Add a Build-Depends on libcjson-dev, and add an upstream patch to build
      against it.
    - Add a Builds-Depends on libnanopb-dev, and add an upstream patch to
      build against it.
    - Pass --enable-c11threads to ./configure, to make sure tinycthread is
      never vendored. (Default was "try", so this was the case already.)
  * Update debian/copyright to reflect newly added dependencies.
  * Update debian/watch to version 5.

 -- Faidon Liambotis <paravoid@debian.org>  Wed, 03 Dec 2025 14:35:41 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  pkgconf,
+ libcjson-dev,
  libcurl4-openssl-dev,
  liblz4-dev,
+ libnanopb-dev,
  libsasl2-dev,
  libssl-dev,
  libzstd-dev,
@@ -56,8 +58,10 @@
 Depends:
  librdkafka++1 (= ${binary:Version}),
  librdkafka1 (= ${binary:Version}),
+ libcjson-dev,
  libcurl4-openssl-dev,
  liblz4-dev,
+ libnanopb-dev,
  libsasl2-dev,
  libssl-dev,
  libzstd-dev,

=== debian/rules ===
--- 
+++ 
@@ -13,5 +13,11 @@
 	@echo 'blhc: ignore-line-regexp:  +LD +ld'
 	@echo 'blhc: ignore-line-regexp:  +CXX +g\+\+'
 
+override_dh_auto_configure:
+	dh_auto_configure -- \
+		--enable-c11threads \
+		--enable-cjson-ext \
+		--enable-nanopb-ext
+
 %:
 	dh $@

=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/confluentinc/@PACKAGE@/git/matching-refs/tags/
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
Download-Url-Mangle: s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g
Filename-Mangle: s/v?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/
Uversion-Mangle: s/-(RC|rc|a|b|c|DEV)/~$1/
Searchmode: plain

## librdkafka 2.13.0

=== debian/changelog ===
librdkafka (2.13.0-1) unstable; urgency=medium

  * De-vendor external dependencies, step 2:
    - Regenerate opentelemetry headers from their sources, using nanopb.
  * Remove Priority: optional, the default now.
  * Update debian/watch to use the Github template.
  * Bump Standards-Version to 4.7.3.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 06 Jan 2026 13:20:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: librdkafka
-Priority: optional
 Maintainer: Faidon Liambotis <paravoid@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
@@ -11,10 +10,12 @@
  libsasl2-dev,
  libssl-dev,
  libzstd-dev,
+ nanopb,
+ opentelemetry-proto,
  python3,
  rapidjson-dev,
  zlib1g-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/confluentinc/librdkafka

=== debian/rules ===
--- 
+++ 
@@ -19,5 +19,27 @@
 		--enable-cjson-ext \
 		--enable-nanopb-ext
 
+# Upstream vendors pregenerated opentelemetry headers and C files under 
+# src/opentelemetry/*.pb.*. Regenerate them here using nanopb, which puts
+# them under the path src/opentelemetry/proto/
+# 
+# This needs a source-level patch alongside it:
+#   debian/patches/Use-nanopb-generated-header-paths-for-opentelemetry.patch
+execute_before_dh_auto_build:
+	-mv src/opentelemetry src/opentelemetry.vendor
+	nanopb_generator \
+		--options-file=src/opentelemetry.vendor/metrics.options \
+		--output-dir=src/ \
+		-L "#include <nanopb/%s>" \
+		-I/usr/include \
+		/usr/include/opentelemetry/proto/common/v1/common.proto \
+		/usr/include/opentelemetry/proto/resource/v1/resource.proto\
+		/usr/include/opentelemetry/proto/metrics/v1/metrics.proto
+
+execute_after_dh_auto_clean:
+	rm -rf src/opentelemetry/proto/
+	-rmdir src/opentelemetry
+	-mv src/opentelemetry.vendor/ src/opentelemetry
+
 %:
 	dh $@

=== debian/watch ===
Version: 5
Template: Github
Owner: confluentinc
Project: librdkafka
Version-Type: STABLE_VERSION
